uniform sampler2D y_texture;
uniform sampler2D cb_texture;
uniform sampler2D cr_texture;
varying highp vec2 vartexcoord;
varying highp float vartexindex;

void main(void)
{
    highp float Y;
    highp float Cb;
    highp float Cr;
    highp float pos = mod((gl_FragCoord.x - 0.5), 4.0);

    if(pos < 1.0) {
        Y = texture2D(y_texture, vartexcoord).r;
        Cb = texture2D(cb_texture, vartexcoord).r;
        Cr = texture2D(cr_texture, vartexcoord).r;
    } else if(pos < 2.0) {
        Y = texture2D(y_texture, vartexcoord).g;
        Cb = texture2D(cb_texture, vartexcoord).g;
        Cr = texture2D(cr_texture, vartexcoord).g;
    } else if(pos < 3.0) {
        Y = texture2D(y_texture, vartexcoord).b;
        Cb = texture2D(cb_texture, vartexcoord).b;
        Cr = texture2D(cr_texture, vartexcoord).b;
    } else {
        Y = texture2D(y_texture, vartexcoord).a;
        Cb = texture2D(cb_texture, vartexcoord).a;
        Cr = texture2D(cr_texture, vartexcoord).a;
    }
    highp float R = Y + 1.402 * (Cr - 0.5);
    highp float G = Y - 0.34414 * (Cb - 0.5) - 0.71414 * (Cr - 0.5);
    highp float B = Y + 1.772 * (Cb - 0.5);
    gl_FragColor = vec4(B, G, R, 1.0);
}
